import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class MainFrame extends JFrame
{
	public MainFrame ()
	{
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing (java.awt.event.WindowEvent evt) {
				System.exit(0);
			}
		});

		Container c = getContentPane();
		c.setLayout(new BorderLayout());
		
		// Center and North Panels
		JPanel pc = new JPanel();
		JPanel pn = new JPanel();

		pc.setLayout(new BoxLayout(pc, BoxLayout.X_AXIS));
		pn.setLayout(new BoxLayout(pn, BoxLayout.X_AXIS));
		
		panel_source   = new PanelImageViewer(PanelImageViewer.TYPE_LOAD, "square.bmp", "Source image");
		panel_fft      = new PanelImageViewer(PanelImageViewer.TYPE_SAVE, "fft.bmp", "FFT result");
		panel_filtre   = new PanelImageViewer(PanelImageViewer.TYPE_LOAD, "filterlow.bmp", "Filter");
		panel_resultat = new PanelImageViewer(PanelImageViewer.TYPE_SAVE, "result.bmp", "Result");

		pn.add(panel_source);		
		pc.add(panel_fft);
		pn.add(panel_filtre);
		pc.add(panel_resultat);
		
		c.add(pn,"North");
		c.add(pc,"Center");
		
		// South panel	
		JPanel pb = new JPanel();
		pb.setLayout(new BoxLayout(pb,BoxLayout.X_AXIS));
		
		JButton   b1  = new JButton("Do FFT");
		JButton   b2  = new JButton("Apply Filter");
		b1.setMaximumSize(new Dimension(100,25));
		b2.setMaximumSize(new Dimension(100,25));
		b1.setPreferredSize(new Dimension(100,25));
		b2.setPreferredSize(new Dimension(100,25));

	
		b1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					panel_fft.setImage(panel_source.getImage().applyFFT(1));
				}
			});

		b2.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					panel_resultat.setImage((panel_source.getImage().applyFilter(cb1.getSelectedIndex(),
								Integer.parseInt(cutoff1.getText()),
								Integer.parseInt(cutoff2.getText()),
								panel_filtre.getImage(), targetSelector.getSelectedIndex())));
				}
			});

		cb1 = new JComboBox();
		cb1.addItem("No filtering");
		cb1.addItem("Low pass");
		cb1.addItem("Band pass");
		cb1.addItem("High pass");
		cb1.addItem("1/r^p");
		cb1.addItem("Image");
		cb1.setSelectedIndex(5);

		targetSelector = new JComboBox();
		targetSelector.addItem("Spectrum");
		targetSelector.addItem("Result");
		targetSelector.setSelectedIndex(1);

		cutoff1 = new JTextField("20");
		cutoff2 = new JTextField("20");
		cutoff1.setColumns(3);
		cutoff2.setColumns(3); 		
		cutoff1.setHorizontalAlignment(JTextField.RIGHT);
		cutoff2.setHorizontalAlignment(JTextField.RIGHT);

		pb.add(b1);
		pb.add(cb1);
		pb.add(cutoff1);
		pb.add(cutoff2);
		pb.add(targetSelector);
		pb.add(b2);
		
		c.add (pb,"South");				
		
		setVisible(true);
		pack();
		setResizable(false);
		setTitle("Programme de dmonstation de FFT bidimensionnelle");
	}

	public static void main (String [] args) 
	{
		(new MainFrame()).setVisible(true);
	}

	protected PanelImageViewer panel_source;
	protected PanelImageViewer panel_fft;
	protected PanelImageViewer panel_filtre; 
	protected PanelImageViewer panel_resultat;
	protected JComboBox cb1;
	protected JComboBox targetSelector;
	protected JTextField cutoff1,cutoff2;
}


	