import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class PanelImageViewer extends JPanel
{
	public static final int TYPE_SAVE = 0;
	public static final int TYPE_LOAD = 1;

	protected String getsType(int type) {
		return (type == TYPE_SAVE) ? "Save" : "Load";
	}

	public PanelImageViewer(int type, String Default, String title)
	{
		this.type = type;
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		JLabel l1 = new JLabel();
		l1.setText(title);
		l1.setAlignmentX(Box.CENTER_ALIGNMENT);

		JPanel p1 = new JPanel();
		p1.setLayout(new BoxLayout(p1,BoxLayout.X_AXIS));

		t1 = new JTextField(Default);
		t1.setAlignmentX(Box.CENTER_ALIGNMENT);
		JButton    b1 = new JButton(getsType(type));
		b1.setAlignmentX(Box.CENTER_ALIGNMENT);
		b1.setMaximumSize(new Dimension(100,20));
		b1.setPreferredSize(new Dimension(100,20));

		ActionListener BACTION = new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					if(getType() == TYPE_LOAD) {
						iffft = new ImageForFFT(t1.getText());
						pi.setImage(iffft.getImage(), iffft.getWidth(), iffft.getHeight());
						pi.repaint();
					} else {
						iffft.save(t1.getText());
					}
				}
			};

		b1.addActionListener(BACTION);
		t1.addActionListener(BACTION);

		p1.add(t1);
		p1.add(b1);

		pi = new PanelImage();
		pi.setBorder(BorderFactory.createRaisedBevelBorder());
		pi.setMinimumSize(new Dimension(256,256));
		pi.setMaximumSize(new Dimension(256,256));
		pi.setPreferredSize(new Dimension(256,256));
		pi.setAlignmentX(Box.CENTER_ALIGNMENT);
		
		add(l1);
		add(p1);
		//add(b1);
		add(pi);

		setBorder(BorderFactory.createEtchedBorder());
	}

	public void setImage(ImageForFFT i) {
		iffft = i;
		pi.setImage(iffft.getImage(), iffft.getWidth(), iffft.getHeight());
		pi.repaint();
	}

	public ImageForFFT getImage() {
		return iffft;
	}

	public int getType() {
		return type;
	}

	protected JTextField t1;
	protected ImageForFFT iffft;
	protected PanelImage pi;
	protected int type;
}